"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bindJsonSchemas = bindJsonSchemas;
var _schema = /*#__PURE__*/require("@traversable/schema");
var JsonSchema = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./jsonSchema.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
const Def = {
  never: _schema.NeverSchema,
  unknown: _schema.UnknownSchema,
  void: _schema.VoidSchema,
  any: _schema.AnySchema,
  null: _schema.NullSchema,
  undefined: _schema.UndefinedSchema,
  symbol: _schema.SymbolSchema,
  boolean: _schema.BooleanSchema,
  integer: _schema.IntegerSchema,
  bigint: _schema.BigIntSchema,
  number: _schema.NumberSchema,
  string: _schema.StringSchema,
  eq: _schema.EqSchema.def,
  optional: _schema.OptionalSchema.def,
  array: _schema.ArraySchema.def,
  record: _schema.RecordSchema.def,
  union: _schema.UnionSchema.def,
  intersect: _schema.IntersectSchema.def,
  object: _schema.ObjectSchema.def,
  tuple: _schema.TupleSchema.def,
  inline: _schema.InlineSchema.def
};
function bindJsonSchemas() {
  void (_schema.NeverSchema.jsonSchema = JsonSchema.NeverJsonSchema.jsonSchema);
  void (_schema.UnknownSchema.jsonSchema = JsonSchema.UnknownJsonSchema.jsonSchema);
  void (_schema.AnySchema.jsonSchema = JsonSchema.AnyJsonSchema.jsonSchema);
  void (_schema.VoidSchema.jsonSchema = JsonSchema.VoidJsonSchema.jsonSchema);
  void (_schema.NullSchema.jsonSchema = JsonSchema.NullJsonSchema.jsonSchema);
  void (_schema.UndefinedSchema.jsonSchema = JsonSchema.UndefinedJsonSchema.jsonSchema);
  void (_schema.BooleanSchema.jsonSchema = Object.assign(Def.boolean, JsonSchema.BooleanJsonSchema).jsonSchema);
  void (_schema.SymbolSchema.jsonSchema = Object.assign(Def.symbol, JsonSchema.SymbolJsonSchema).jsonSchema);
  void (_schema.IntegerSchema.jsonSchema = Object.assign(Def.integer, JsonSchema.IntegerJsonSchema).jsonSchema);
  void (_schema.BigIntSchema.jsonSchema = Object.assign(Def.bigint, JsonSchema.BigIntJsonSchema).jsonSchema);
  void (_schema.NumberSchema.jsonSchema = Object.assign(Def.number, JsonSchema.NumberJsonSchema).jsonSchema);
  void (_schema.StringSchema.jsonSchema = Object.assign(Def.string, JsonSchema.StringJsonSchema).jsonSchema);
  void (_schema.EqSchema.def = (x, options) => Object.assign(Def.eq(x, options), JsonSchema.EqJsonSchema(x)));
  void (_schema.OptionalSchema.def = x => Object.assign(Def.optional(x), JsonSchema.OptionalJsonSchema(x)));
  void (_schema.RecordSchema.def = x => Object.assign(Def.record(x), JsonSchema.RecordJsonSchema(x)));
  void (_schema.ArraySchema.def = x => Object.assign(Def.array(x), JsonSchema.ArrayJsonSchema(x)));
  void (_schema.UnionSchema.def = xs => Object.assign(Def.union(xs), JsonSchema.UnionJsonSchema(xs)));
  void (_schema.IntersectSchema.def = xs => Object.assign(Def.intersect(xs), JsonSchema.IntersectJsonSchema(xs)));
  void (_schema.TupleSchema.def = (xs, options) => Object.assign(Def.tuple(xs, options), JsonSchema.TupleJsonSchema(xs)));
  void (_schema.ObjectSchema.def = (xs, options) => Object.assign(Def.object(xs, options), JsonSchema.ObjectJsonSchema(xs)));
}
//# sourceMappingURL=bind.js.map