import type { HKT } from '@traversable/registry';
import { t } from '@traversable/schema';
export declare const RAW: {
    any: {
        type: "object";
        properties: {};
        nullable: true;
    };
    null: {
        type: "null";
        enum: [null];
    };
    boolean: {
        type: "boolean";
    };
    integer: {
        type: "integer";
    };
    number: {
        type: "number";
    };
    string: {
        type: "string";
    };
};
interface JsonSchema_any {
    type: 'object';
    properties: {};
    nullable: true;
}
declare const JsonSchema_any: t.eq<{
    type: "object";
    properties: {};
    nullable: true;
}>;
interface JsonSchema_null {
    type: 'null';
    enum: [null];
}
declare const JsonSchema_null: t.eq<{
    type: "null";
    enum: [null];
}>;
interface JsonSchema_boolean {
    type: 'boolean';
}
declare const JsonSchema_boolean: t.eq<{
    type: "boolean";
}>;
interface JsonSchema_integer {
    type: 'integer';
}
declare const JsonSchema_integer: t.eq<{
    type: "integer";
}>;
interface JsonSchema_number {
    type: 'number';
}
declare const JsonSchema_number: t.eq<{
    type: "number";
}>;
interface JsonSchema_string {
    type: 'string';
}
declare const JsonSchema_string: t.eq<{
    type: "string";
}>;
interface JsonSchema_const<T = unknown> {
    const: T;
}
declare const JsonSchema_const: t.object<{
    const: t.unknown;
}>;
interface JsonSchema_enum<T = unknown> {
    enum: readonly T[];
}
declare const JsonSchema_enum: t.object<{
    enum: t.ReadonlyArray<t.unknown>;
}>;
interface JsonSchema_array<T> {
    type: 'array';
    items: T;
}
declare const JsonSchema_array: t.object<{
    type: t.eq<"array">;
    items: t.unknown;
}>;
interface JsonSchema_record<T = unknown> {
    type: 'object';
    additionalProperties: T;
}
declare const JsonSchema_record: <T>(u: unknown) => u is JsonSchema_record<T>;
interface JsonSchema_union<T = unknown> {
    anyOf: T;
}
declare const JsonSchema_union: t.inline<(u: unknown) => u is JsonSchema_union>;
interface JsonSchema_intersect<T = unknown> {
    allOf: T;
}
declare const JsonSchema_intersect: t.inline<(u: unknown) => u is JsonSchema_intersect>;
interface JsonSchema_object<T> {
    type: 'object';
    required: string[];
    properties: T;
}
declare const JsonSchema_object: t.object<{
    type: t.eq<"object">;
    required: t.array<t.string>;
    properties: t.unknown;
}>;
interface JsonSchema_tuple<T> {
    type: 'array';
    items: T;
    minItems: number;
    maxItems: number;
    additionalItems: false;
}
declare const JsonSchema_tuple: t.object<{
    type: t.eq<"array">;
    items: t.unknown;
    minItems: t.number;
    maxItems: t.number;
    additionalItems: t.eq<false>;
}>;
export declare const is: {
    any: t.eq<{
        type: "object";
        properties: {};
        nullable: true;
    }>;
    null: t.eq<{
        type: "null";
        enum: [null];
    }>;
    boolean: t.eq<{
        type: "boolean";
    }>;
    integer: t.eq<{
        type: "integer";
    }>;
    number: t.eq<{
        type: "number";
    }>;
    string: t.eq<{
        type: "string";
    }>;
    enum: t.object<{
        enum: t.ReadonlyArray<t.unknown>;
    }>;
    const: t.object<{
        const: t.unknown;
    }>;
    array: t.object<{
        type: t.eq<"array">;
        items: t.unknown;
    }>;
    record: <T>(u: unknown) => u is JsonSchema_record<T>;
    union: t.inline<(u: unknown) => u is JsonSchema_union>;
    intersect: t.inline<(u: unknown) => u is JsonSchema_intersect>;
    tuple: t.object<{
        type: t.eq<"array">;
        items: t.unknown;
        minItems: t.number;
        maxItems: t.number;
        additionalItems: t.eq<false>;
    }>;
    object: t.object<{
        type: t.eq<"object">;
        required: t.array<t.string>;
        properties: t.unknown;
    }>;
    nullary: t.union<[t.eq<{
        type: "object";
        properties: {};
        nullable: true;
    }>, t.eq<{
        type: "null";
        enum: [null];
    }>, t.eq<{
        type: "boolean";
    }>, t.eq<{
        type: "integer";
    }>, t.eq<{
        type: "number";
    }>, t.eq<{
        type: "string";
    }>]>;
    unary: t.union<[t.object<{
        type: t.eq<"array">;
        items: t.unknown;
    }>, <T>(u: unknown) => u is JsonSchema_record<T>, t.inline<(u: unknown) => u is JsonSchema_union>, t.inline<(u: unknown) => u is JsonSchema_intersect>, t.object<{
        type: t.eq<"array">;
        items: t.unknown;
        minItems: t.number;
        maxItems: t.number;
        additionalItems: t.eq<false>;
    }>, t.object<{
        type: t.eq<"object">;
        required: t.array<t.string>;
        properties: t.unknown;
    }>]>;
    special: t.union<[t.object<{
        enum: t.ReadonlyArray<t.unknown>;
    }>, t.object<{
        const: t.unknown;
    }>]>;
};
export type Nullary = JsonSchema_any | JsonSchema_null | JsonSchema_boolean | JsonSchema_integer | JsonSchema_number | JsonSchema_string;
export type JsonSchema = Nullary | JsonSchema_const | JsonSchema_enum | JsonSchema_array<JsonSchema> | JsonSchema_record<JsonSchema> | JsonSchema_union<readonly JsonSchema[]> | JsonSchema_intersect<readonly JsonSchema[]> | JsonSchema_tuple<readonly JsonSchema[]> | JsonSchema_object<{
    [x: string]: JsonSchema;
}>;
export type Unary<T> = Nullary | JsonSchema_const | JsonSchema_enum | JsonSchema_array<T> | JsonSchema_record<T> | JsonSchema_union<readonly T[]> | JsonSchema_intersect<readonly T[]> | JsonSchema_tuple<readonly T[]> | JsonSchema_object<{
    [x: string]: T;
}>;
export interface Free extends HKT {
    [-1]: Unary<this[0]>;
}
export {};
//# sourceMappingURL=specification.d.ts.map