import { NeverSchema, UnknownSchema, VoidSchema, AnySchema, NullSchema, UndefinedSchema, SymbolSchema, BooleanSchema, IntegerSchema, BigIntSchema, NumberSchema, StringSchema, EqSchema, OptionalSchema, ArraySchema, RecordSchema, UnionSchema, IntersectSchema, TupleSchema, ObjectSchema, InlineSchema } from '@traversable/schema';
import * as JsonSchema from './jsonSchema.js';
const Def = {
  never: NeverSchema,
  unknown: UnknownSchema,
  void: VoidSchema,
  any: AnySchema,
  null: NullSchema,
  undefined: UndefinedSchema,
  symbol: SymbolSchema,
  boolean: BooleanSchema,
  integer: IntegerSchema,
  bigint: BigIntSchema,
  number: NumberSchema,
  string: StringSchema,
  eq: EqSchema.def,
  optional: OptionalSchema.def,
  array: ArraySchema.def,
  record: RecordSchema.def,
  union: UnionSchema.def,
  intersect: IntersectSchema.def,
  object: ObjectSchema.def,
  tuple: TupleSchema.def,
  inline: InlineSchema.def
};
export function bindJsonSchemas() {
  void (NeverSchema.jsonSchema = JsonSchema.NeverJsonSchema.jsonSchema);
  void (UnknownSchema.jsonSchema = JsonSchema.UnknownJsonSchema.jsonSchema);
  void (AnySchema.jsonSchema = JsonSchema.AnyJsonSchema.jsonSchema);
  void (VoidSchema.jsonSchema = JsonSchema.VoidJsonSchema.jsonSchema);
  void (NullSchema.jsonSchema = JsonSchema.NullJsonSchema.jsonSchema);
  void (UndefinedSchema.jsonSchema = JsonSchema.UndefinedJsonSchema.jsonSchema);
  void (BooleanSchema.jsonSchema = Object.assign(Def.boolean, JsonSchema.BooleanJsonSchema).jsonSchema);
  void (SymbolSchema.jsonSchema = Object.assign(Def.symbol, JsonSchema.SymbolJsonSchema).jsonSchema);
  void (IntegerSchema.jsonSchema = Object.assign(Def.integer, JsonSchema.IntegerJsonSchema).jsonSchema);
  void (BigIntSchema.jsonSchema = Object.assign(Def.bigint, JsonSchema.BigIntJsonSchema).jsonSchema);
  void (NumberSchema.jsonSchema = Object.assign(Def.number, JsonSchema.NumberJsonSchema).jsonSchema);
  void (StringSchema.jsonSchema = Object.assign(Def.string, JsonSchema.StringJsonSchema).jsonSchema);
  void (EqSchema.def = (x, options) => Object.assign(Def.eq(x, options), JsonSchema.EqJsonSchema(x)));
  void (OptionalSchema.def = x => Object.assign(Def.optional(x), JsonSchema.OptionalJsonSchema(x)));
  void (RecordSchema.def = x => Object.assign(Def.record(x), JsonSchema.RecordJsonSchema(x)));
  void (ArraySchema.def = x => Object.assign(Def.array(x), JsonSchema.ArrayJsonSchema(x)));
  void (UnionSchema.def = xs => Object.assign(Def.union(xs), JsonSchema.UnionJsonSchema(xs)));
  void (IntersectSchema.def = xs => Object.assign(Def.intersect(xs), JsonSchema.IntersectJsonSchema(xs)));
  void (TupleSchema.def = (xs, options) => Object.assign(Def.tuple(xs, options), JsonSchema.TupleJsonSchema(xs)));
  void (ObjectSchema.def = (xs, options) => Object.assign(Def.object(xs, options), JsonSchema.ObjectJsonSchema(xs)));
}
//# sourceMappingURL=bind.js.map